package serializar.com.daniminguet.es;

import javafx.application.Application;
import javafx.collections.FXCollections;
import javafx.fxml.FXML;
import javafx.fxml.FXMLLoader;
import javafx.scene.Scene;
import javafx.scene.control.TableColumn;
import javafx.scene.control.TableView;
import javafx.scene.control.cell.PropertyValueFactory;
import javafx.scene.layout.GridPane;
import javafx.scene.layout.VBox;
import javafx.stage.Stage;

import java.io.*;
import java.util.ArrayList;
import java.util.Arrays;

public class AplicacionPersona extends Application {
    @Override
    public void start(Stage stage) throws IOException {
        mostrarPersonasFichero();

        /** Me da fallo en el "fxmlLoader.load()", por lo tanto no me inicia el progra ni puedo ver
         * si se añaden las personas a la tabla
        FXMLLoader fxmlLoader = new FXMLLoader(AplicacionPersona.class.getResource("person-list"));
        Scene scene = new Scene(fxmlLoader.load(), 320, 240);
        stage.setTitle("Datos personas");
        stage.setScene(scene);
        stage.show();
         **/
    }

    @Override
    public void init() throws Exception {
        System.out.println("init() method: " + Thread.currentThread().getName());
    }

    @Override
    public void stop() throws Exception {
        System.out.println("stop() method: " + Thread.currentThread().getName());
    }

    public void mostrarPersonasFichero() {
        File fichero = new File("C:\\Users\\Dani\\OneDrive\\Documentos\\AccesoADatos\\Personas.dat");
        FileInputStream filein = null;
        try {
            filein = new FileInputStream(fichero);
        } catch (FileNotFoundException e) {
            throw new RuntimeException(e);
        }
        ObjectInputStream dataIS = null;
        try {
            dataIS = new ObjectInputStream(filein);
        } catch (IOException ioe) {

        }

        String[] nombres;
        int[] edades;
        //Lee los datos del archivo
        try {
            nombres = (String[]) dataIS.readObject();
            edades = (int[]) dataIS.readObject();
        } catch (IOException e) {
            throw new RuntimeException(e);
        } catch (ClassNotFoundException e) {
            throw new RuntimeException(e);
        }

        //Se crea la lista que contendrá las personas
        ArrayList<Persona> personas = new ArrayList<>();

        //Se recorren los datos de las personas y se crean y añaden en la lista
        for (int i = 0; i < nombres.length; i++) {
            personas.add(new Persona(nombres[i], edades[i]));
        }

        //Se muestran las personas por pantalla
        for (int i = 0; i < personas.size(); i++) {
            System.out.println("Nombre: " + personas.get(i).getNombre() + "\t\tEdad: " + personas.get(i).getEdad());
        }

        try {
            dataIS.close();
        } catch (IOException e) {
            throw new RuntimeException(e);
        }

    }
}
